package com.lodgon.dali.core.social.entity;

import com.lodgon.dali.core.entity.User;
import java.io.Serializable;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToOne;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author joeri
 */
@Entity
@NamedQueries({
  @NamedQuery(
    name = "OnlineAccount.findByAppKeyAndNetworkAndAccountId",
    query = "SELECT oa FROM OnlineAccount oa WHERE oa.appKey = :appKey AND oa.network = :network AND oa.accountId = :accountId ORDER BY oa.creationDate DESC"
  ),
  @NamedQuery(
    name = "OnlineAccount.findByAppKeyAndUser",
    query = "SELECT oa FROM OnlineAccount oa WHERE oa.appKey = :appKey AND oa.user = :user ORDER BY oa.creationDate DESC"
  ),
  @NamedQuery(
    name = "OnlineAccount.findByUserAndNetwork",
    query = "SELECT oa FROM OnlineAccount oa WHERE oa.user = :user AND oa.network = :network ORDER BY oa.creationDate DESC"
  )
})
@XmlRootElement
@XmlAccessorType(XmlAccessType.PROPERTY)
public class OnlineAccount implements Serializable {
  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private Long id;
  private long creationDate;

  @ManyToOne
  private User user;

  @OneToOne
  private ExternalToken accessToken;

  private String network;
  private String accountId;
	private String appKey;

	@XmlTransient
  public ExternalToken getAccessToken() {
    return accessToken;
  }

  public void setAccessToken(ExternalToken accessToken) {
    this.accessToken = accessToken;
  }

  public String getAccountId() {
    return accountId;
  }

  public void setAccountId(String accountId) {
    this.accountId = accountId;
  }

	public String getAppKey() {
		return appKey;
	}

	public void setAppKey(String appKey) {
		this.appKey = appKey;
	}

  public long getCreationDate() {
    return creationDate;
  }

  public void setCreationDate(long creationDate) {
    this.creationDate = creationDate;
  }

  public String getNetwork() {
    return network;
  }

  public void setNetwork(String network) {
    this.network = network;
  }

  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

	@XmlTransient
  public User getUser() {
    return user;
  }

  public void setUser(User user) {
    this.user = user;
  }
}
