package com.lodgon.dali.core.social.filter;

import java.util.EnumSet;
import java.util.LinkedList;
import java.util.List;
import javax.servlet.DispatcherType;
import javax.servlet.FilterRegistration;
import javax.servlet.ServletContext;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import javax.servlet.annotation.WebListener;

/**
 *
 * @author Joeri
 */
@WebListener
public class FilterConfiguration implements ServletContextListener {
	@Override
	public void contextInitialized(ServletContextEvent sce) {
		ServletContext sc = sce.getServletContext();
		FilterRegistration responseFormatFilterRegistration = sc.getFilterRegistration("ResponseFormatFilter");
		if (responseFormatFilterRegistration == null) {
			responseFormatFilterRegistration = sc.addFilter("ResponseFormatFilter", ResponseFormatFilter.class);
		}

		if (responseFormatFilterRegistration != null) {
			List<String> urlPatterns = new LinkedList<String>();
			urlPatterns.add("/*");
			responseFormatFilterRegistration.addMappingForUrlPatterns(EnumSet.of(DispatcherType.REQUEST, DispatcherType.FORWARD), true, urlPatterns.toArray(new String[]{}));
		}
	}

	@Override
	public void contextDestroyed(ServletContextEvent sce) {
	}
}
