package com.lodgon.dali.core.social.filter;

import java.io.IOException;
import java.util.Collections;
import java.util.Enumeration;
import java.util.LinkedList;
import java.util.List;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletRequestWrapper;

/**
 *
 * @author Joeri
 */
@WebFilter(filterName = "ResponseFormatFilter")
public class ResponseFormatFilter implements Filter {
  private FilterConfig filterConfig = null;

  @Override
  public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {
		chain.doFilter(new AcceptHeaderHttpServletRequestWrapper((HttpServletRequest) request), response);
  }

	private class AcceptHeaderHttpServletRequestWrapper extends HttpServletRequestWrapper {
		public AcceptHeaderHttpServletRequestWrapper(HttpServletRequest request) {
			super(request);
		}

		@Override
		public Enumeration<String> getHeaders(String name) {
			if ("accept".equalsIgnoreCase(name)) {
				String queryString = super.getQueryString();
				if (queryString != null) {
					String[] queryParameters = queryString.split("&");
					for (String queryParameter : queryParameters) {
						if ("format=xml".equals(queryParameter)) {
							List<String> headers = new LinkedList<String>();
							headers.add("application/xml");
							System.out.println("headers = " + headers);
							return Collections.enumeration(headers);
						} else if ("format=json".equals(queryParameter)) {
							List<String> headers = new LinkedList<String>();
							headers.add("application/json");
							System.out.println("headers = " + headers);
							return Collections.enumeration(headers);
						}
					}
				}
			}
			return super.getHeaders(name);
		}
	}

  /**
   * Return the filter configuration object for this filter.
   */
  public FilterConfig getFilterConfig() {
    return (this.filterConfig);
  }

  /**
   * Set the filter configuration object for this filter.
   *
   * @param filterConfig The filter configuration object
   */
  public void setFilterConfig(FilterConfig filterConfig) {
    this.filterConfig = filterConfig;
  }

  /**
   * Destroy method for this filter 
   */
  @Override
  public void destroy() {
  }

  /**
   * Init method for this filter 
   */
  @Override
  public void init(FilterConfig filterConfig) {
    this.filterConfig = filterConfig;
  }	
}
